#include <Windows.h>
#include <wincred.h>
#include <iostream>

using namespace std;

/*
Credential Manager - Zip archives password retrieval for Win 8.x - Win 10
Author: kyREcon
*/

int main()
{

	PCREDENTIALW * credBuf = NULL;

	DWORD count;

	CredEnumerateW(L"*.zip", NULL, &count, &credBuf);

	if (ERROR_NOT_FOUND == GetLastError())
	{
		wcout << endl << "No credentials found in the user's credential set." << endl;
		goto __cleanup;
	}

	if (!credBuf)
	{
		wcout << endl << "Memory Allocation Failed!" << endl;
		goto __cleanup;
	}


	for (DWORD i = 0; i < count; i++)
	{
		if (((*credBuf[i]).CredentialBlob) && ((*credBuf[i]).TargetName))
		{
			wcout << endl << "------------------------------------------------------" << endl;
			wcout << "Target: " << (wchar_t *)(*credBuf[i]).TargetName << endl << endl;
			wcout << "Password: " << (wchar_t *)(*credBuf[i]).CredentialBlob << endl;
			wcout << "------------------------------------------------------" << endl << endl;
		}
	}

__cleanup:

	if (credBuf)
	{
		CredFree(credBuf);
		credBuf = NULL;
	}

	cin.get();
	return 0;

}